; This is a Scheme program that transform a soccer XML-in-LAML document to
; a simple overview of some soccer games. This Scheme program is similar to an XSLT program.

(lib-load "xml-in-laml/mirrors/xhtml10-transitional-mirror.scm")

(define text-contents aggregated-ast-cdata-contents) ; alias

(define (results! soccer-ast)
 (let* ((ttl (list "Result of group" (get-prop 'group (ast-attributes soccer-ast))))
        (html-ast 
         (html 
          (head (title ttl))
          (body
            (h1 ttl)
            (present-matches soccer-ast)))))
   (write-html '(pp) html-ast)))

(define (present-matches soccer-ast)
  (traverse-and-collect-all-from-ast 
    soccer-ast
    (ast-of-type? 'element-name 'match)
    (lambda (match-ast)
      (let* ((team1 (sub-ast match-ast 'team 1))
	     (team1-score (get-prop 'score (ast-attributes team1)))
	     (team2 (sub-ast match-ast 'team 2))
	     (team2-score (get-prop 'score (ast-attributes team2)))
	     (dt (sub-ast match-ast 'date)))
	(list 
	 (h2 (text-contents team1) "versus" (text-contents team2))
	 (p "Played on" (text-contents dt))
	 (p "Result:"
	    (text-contents team1) team1-score _ ","
	    (text-contents team2) team2-score))))))

  


